<?php
class Helpers {

    public static function GetHours($hour = false) {
        $z = 1;
        $type = ' AM';
        for ($i = 0; $i <= 23; $i++) {
            if ($i == 0) {
                $type = ' PM';
                $z = 12;
            } elseif ($i == 1) {
                $type = ' AM';
                $z = 1;
            } elseif ($i == 13) {
                $type = ' PM';
                $z = 1;
            }

            if ($i < 10)
                $hours[$i] = $z . ':00' . $type;
            else
                $hours[$i] = $z . ':00' . $type;
            if (is_numeric($hour) && $hour == $i)
                return $hours[$i];
            $z++;
        }
        return $hours;
    }

    public static function get_credit_supported()
    {
        return array (
          'Visa'=>'Visa',
          'MasterCard'=>'MasterCard',
          'American Express'=>'American Express',
          'Discover'=>'Discover',
          'JCB'=>'JCB',
          'Diner\'s Club'=>'Diner\'s Club',
          'EnRoute'=>'EnRoute',
        );
    }

    public static function get_country_code()
    {
        return array (
          'AU'=>'AUSTRALIA',
          'BR'=>'BRAZIL',
          'CA'=>'CANADA',
          'GB'=>'UNITED KINGDOM',
          'US'=>'UNITED STATES',
        );
    }

    public static function check_in_range($start_date, $end_date, $date_from_user)
    {
      $start_ts = strtotime($start_date);
      $end_ts = strtotime($end_date);
      $user_ts = strtotime($date_from_user);

      return (($user_ts >= $start_ts) && ($user_ts <= $end_ts));
    }

    public static function json_encodealt($a=false)
    {
        if (is_null($a)) return 'null';
        if ($a === false) return 'false';
        if ($a === true) return 'true';
        if (is_scalar($a))
        {
            if (is_float($a))
            {
                return floatval(str_replace(',', '.', strval($a)));
            }
            if (is_string($a))
            {
                static $jsonReplaces = array(array('\\', '/', "\n", "\t", "\r", "\b", "\f", '"'), array('\\\\', '\\/', '\\n', '\\t', '\\r', '\\b', '\\f', '\"'));
                return '"' . str_replace($jsonReplaces[0], $jsonReplaces[1], $a) . '"';
            }
            else
                return $a;
        }
        $isList = true;
        for ($i = 0, reset($a); true; $i++) {
            if (key($a) !== $i)
            {
                $isList = false;
                break;
            }
        }
        $result = array();
        if ($isList)
        {
            foreach ($a as $v) $result[] = json_encode($v);
            return '[' . join(',', $result) . ']';
        }
        else
        {
            foreach ($a as $k => $v) $result[] = json_encode($k).':'.json_encode($v);
            return '{' . join(',', $result) . '}';
        }
    }

    public static function ValidateZipTable($zipcode) {
        $zipoption = MMSettingsForm::getParam('zip_type');
        switch ((int) $zipoption) {
            case 0:
                $ziptable[] = MMSettingsForm::getParam('zip_self');
                break;
            case 1:
                $ziptable = unserialize(MMSettingsForm::getParam('zip_list'));
                break;
            case 2:
                $ziptable = unserialize(MMSettingsForm::getParam('zip_list'));
                $ziptable[] = MMSettingsForm::getParam('zip_self');
                break;
            default:
                $ziptable = unserialize(MMSettingsForm::getParam('zip_list'));
                $ziptable[] = MMSettingsForm::getParam('zip_self');
                break;
        }
        if (in_array($zipcode, $ziptable)) {
            return true;
        } else {
            if (strlen(strpos($zipcode, '-')) > 0) {
                $zipcode = substr($zipcode, 0, 5);
                if (in_array($zipcode, $ziptable)) {
                    return true;
                }
                else
                    return false;
            }
            return false;
        }
        return false;
    }

    public static function GetHoursPopUp() {
        $worktime = unserialize(MMSettingsForm::getParam('work_time'));
        $daysofweek = array('0' => 'Sunday', '1' => 'Monday', '2' => 'Tuesday', '3' => 'Wednesday', '4' => 'Thursday', '5' => 'Friday', '6' => 'Saturday');
        $hours_array = Helpers::GetHours();
        $data = ' Working Hours:<br>';
        foreach ($worktime as $key => $day) {
            if ($day['active'] == '1') {
                $data.='<b>' . $daysofweek[$key] . ':</b> ' . $hours_array[(int) $day['from']] . ' - ' . $hours_array[(int) $day['to']] . '<br>';
            }
        }
        $data.='';
        return $data;
    }

    public static function renderErrors($errors) {
        if (!empty($errors)) {
            echo '<div class="wpmm-form-error"><ul>';
            foreach ($errors as $error) {
                if (!empty($error)) {
                    if (is_array($error)) {
                        foreach ($error as $err) {
                            if (!empty($err))
                                echo '<li>' . $err . '</li>';
                        }
                    }
                    else
                        echo '<li>' . $error . '</li>';
                }
            }
            echo '</ul></div>';
        }
    }

    public static function renderInfo($messages) {
        echo '<div class="wpmm-form-info"><ul>';
        foreach ($messages as $message) {
            if (!empty($message))
                echo '<li>' . $message . '</li>';
        }
        echo '</ul></div>';
    }

    public static function randomPassword() {
        return substr(sha1(uniqid()), 0, 10);
    }

    public static function getTimezone() {
                $timezone = array(
            'Australia/Adelaide'            => 'Australia - Adelaide',
            'Australia/Brisbane'            => 'Australia - Brisbane',
            'Australia/Broken_Hill'         => 'Australia - Broken Hill',
            'Australia/Currie'              => 'Australia - Currie',
            'Australia/Darwin'              => 'Australia - Darwin',
            'Australia/Eucla'               => 'Australia - Eucla',
            'Australia/Hobart'              => 'Australia - Hobart',
            'Australia/Lindeman'            => 'Australia - Lindeman',
            'Australia/Lord_Howe'           => 'Australia - Lord Howe',
            'Australia/Melbourne'           => 'Australia - Melbourne',
            'Australia/Perth'               => 'Australia - Perth',
            'Australia/Sydney'              => 'Australia - Sydney',
            'America/Atikokan'              => 'Canada - Atikokan',
            'America/Blanc-Sablon'          => 'Canada - Blanc-Sablon',
            'America/Cambridge_Bay'         => 'Canada - Cambridge Bay',
            'America/Creston'               => 'Canada - Creston',
            'America/Dawson'                => 'Canada - Dawson',
            'America/Dawson_Creek'          => 'Canada - Dawson Creek',
            'America/Edmonton'              => 'Canada - Edmonton',
            'America/Glace_Bay'             => 'Canada - Glace Bay',
            'America/Goose_Bay'             => 'Canada - Goose Bay',
            'America/Halifax'               => 'Canada - Halifax',
            'America/Inuvik'                => 'Canada - Inuvik',
            'America/Iqaluit'               => 'Canada - Iqaluit',
            'America/Moncton'               => 'Canada - Moncton',
            'America/Montreal'              => 'Canada - Montreal',
            'America/Nipigon'               => 'Canada - Nipigon',
            'America/Pangnirtung'           => 'Canada - Pangnirtung',
            'America/Rainy_River'           => 'Canada - Rainy River',
            'America/Rankin_Inlet'          => 'Canada - Rankin Inlet',
            'America/Regina'                => 'Canada - Regina',
            'America/Resolute'              => 'Canada - Resolute',
            'America/St_Johns'              => 'Canada - St Johns',
            'America/Swift_Current'         => 'Canada - Swift Current',
            'America/Thunder_Bay'           => 'Canada - Thunder Bay',
            'America/Toronto'               => 'Canada - Toronto',
            'America/Vancouver'             => 'Canada - Vancouver',
            'America/Whitehorse'            => 'Canada - Whitehorse',
            'America/Winnipeg'              => 'Canada - Winnipeg',
            'America/Yellowknife'           => 'Canada - Yellowknife',
            'Europe/London'                 => 'United Kingdom',
            'America/Adak'                  => 'USA - Adak',
            'America/Anchorage'             => 'USA - Anchorage',
            'America/Boise'                 => 'USA - Boise',
            'America/Chicago'               => 'USA - Chicago',
            'America/Denver'                => 'USA - Denver',
            'America/Detroit'               => 'USA - Detroit',
            'Pacific/Honolulu'              => 'USA - Honolulu',
            'America/Indiana/Indianapolis'  => 'USA - Indiana / Indianapolis',
            'America/Indiana/Knox'          => 'USA - Indiana / Knox',
            'America/Indiana/Marengo'       => 'USA - Indiana / Marengo',
            'America/Indiana/Petersburg'    => 'USA - Indiana / Petersburg',
            'America/Indiana/Tell_City'     => 'USA - Indiana / Tell City',
            'America/Indiana/Vevay'         => 'USA - Indiana / Vevay',
            'America/Indiana/Vincennes'     => 'USA - Indiana / Vincennes',
            'America/Indiana/Winamac'       => 'USA - Indiana / Winamac',
            'America/Juneau'                => 'USA - Juneau',
            'America/Kentucky/Louisville'   => 'USA - Kentucky / Louisville',
            'America/Kentucky/Monticello'   => 'USA - Kentucky / Monticello',
            'America/Los_Angeles'           => 'USA - Los Angeles',
            'America/Menominee'             => 'USA - Menominee',
            'America/Metlakatla'            => 'USA - Metlakatla',
            'America/New_York'              => 'USA - New York',
            'America/Nome'                  => 'USA - Nome',
            'America/North_Dakota/Beulah'   => 'USA - North Dakota / Beulah',
            'America/North_Dakota/Center'   => 'USA - North Dakota / Center',
            'America/North_Dakota/New_Salem'=> 'USA - North Dakota / New Salem',
            'America/Phoenix'               => 'USA - Phoenix',
            'America/Shiprock'              => 'USA - Shiprock',
            'America/Sitka'                 => 'USA - Sitka',
            'America/Yakutat'               => 'USA - Yakutat',
        );
        return $timezone;
    }

    public static function enumDropDownList($model, $attribute, $htmlOptions = array()) {
        return CHtml::activeDropDownList($model, $attribute, self::enumItem($model, $attribute), $htmlOptions);
    }

    public static function GetAddressList() {
        $order = Yii::app()->session['wpmm_order'];
        $list = array();
        if (!Yii::app()->user->isGuest) {
            $user = MMCustomer::model()->findByPk(Yii::app()->user->id);
            if ($user) {
                if ($user->addresses) {
                    foreach ($user->addresses as $address_tmp) {
                        $address = '';
                        if (!empty($address_tmp->address)) {
                            $address .= $address_tmp->address;
                            if (!empty($address_tmp->city))
                                $address .= ', ' . $address_tmp->city;
                            if (!empty($address_tmp->state))
                                $address .= ', ' . $address_tmp->state;
                            if (!empty($address_tmp->location))
                                $address .= ', ' . $address_tmp->location;
                        }
                        $list[$address_tmp->id] = $address;
                    }
                }
            }
        }
        if (isset($order['address'])) {
            foreach ($order['address'] as $addr) {
                $address = '';
                if (!empty($addr['address'])) {
                    $address.=$addr['address'];
                    if (!empty($addr['city']))
                        $address.=', ' . $addr['city'];
                    if (!empty($addr['state']))
                        $address.=', ' . $addr['state'];
                    if (!empty($addr['location']))
                        $address.=', ' . $addr['location'];
                }
                $list[$addr['id']] = $address;
            }
        }
        return $list;
    }

    public static function enumItem($model, $attribute) {
        $attr = $attribute;
        CHtml::resolveName($model, $attr);
        preg_match('/\((.*)\)/', $model->tableSchema->columns[$attr]->dbType, $matches);
        foreach (explode(',', $matches[1]) as $value) {
            $value = str_replace("'", null, $value);
            $values[$value] = $value;
        }
        return $values;
    }

    public static function enumItemArray($model, $attribute) {
        $attr = $attribute;
        CHtml::resolveName($model, $attr);
        $values[''] = 'Select...';
        preg_match('/\((.*)\)/', $model->tableSchema->columns[$attr]->dbType, $matches);
        foreach (explode(',', $matches[1]) as $value) {
            $value = str_replace("'", null, $value);
            $values[$value] = $value;
        }
        return $values;
    }

    public static function rmdirr($dirname, $root = '') {
        if (!file_exists($dirname))
            return false;
        if (is_file($dirname) || is_link($dirname))
            return unlink($dirname);
        $dir = dir($dirname);
        while (false !== $entry = $dir->read()) {
            if ($entry == '.' || $entry == '..')
                continue;
            self::rmdirr($dirname . DIRECTORY_SEPARATOR . $entry, $root);
        }
        $dir->close();
        if ($dirname == $root)
            return true;
        else
            return rmdir($dirname);
    }

    public static function activeCheckBoxListMany($model, $attribute, $data, $htmlOptions = array()) {
        CHtml::resolveNameID($model, $attribute, $htmlOptions);
        if (is_array($model->$attribute) && isset($htmlOptions['attributeitem']) && $htmlOptions['attributeitem']) {
            $selection = array();
            foreach ($model->$attribute as $a)
                $selection[] = $a->$htmlOptions['attributeitem'];
        } else {
            $selection = $model->$attribute;
        }
        if ($model->hasErrors($attribute))
            self::addErrorCss($htmlOptions);
        $name = $htmlOptions['name'];
        unset($htmlOptions['name']);
        if (array_key_exists('uncheckValue', $htmlOptions)) {
            $uncheck = $htmlOptions['uncheckValue'];
            unset($htmlOptions['uncheckValue']);
        }
        else
            $uncheck = '';
        $hiddenOptions = isset($htmlOptions['id']) ? array('id' => CHtml::ID_PREFIX . $htmlOptions['id']) : array('id' => false);
        $hidden = $uncheck !== null ? CHtml::hiddenField($name, $uncheck, $hiddenOptions) : '';
        return $hidden . CHtml::checkBoxList($name, $selection, $data, $htmlOptions);
    }

    public static function getSessionOrder() {
        return Yii::app()->session['wpmm_order'];
    }

    public static function setSessionOrder(array $order) {
        Yii::app()->session['wpmm_order'] = $order;
    }

    public static function arrayToFloat($array) {
        if (is_null($array))
            return;
        foreach ($array as $key => $data)
            if (!empty($data))
                $float_array[$key] = (float) $data;
        return $float_array;
    }

    public static function addSessionItem(array $order, array $post) {
        $order['items'][] = array(
            'id' => (int) $post['id'],
            'quantity' => (int) $post['quantity'],
            'price' => (float) $post['price'],
            'instructions' => trim(strip_tags($post['instructions'])),
            'attributes' => Helpers::arrayToFloat($post['attr']),
        );
        return $order;
    }

    public static function getItemById($id) {
        return MMItem::model()->findByPk($id);
    }

    public static function getAttrById($id) {
        return MMAttribute::model()->findByPk($id);
    }

    public static function addSessionAddress($order, array $post) {
        $address_id = '';
        if (!isset($post['id'])) {
            $address_id = uniqid('address');
            $order['address'][] = array(
                'id' => $address_id,
                'city' => trim(strip_tags($post['city'])),
                'state' => trim(strip_tags($post['state'])),
                'address' => trim(strip_tags($post['address'])),
                'location' => trim(strip_tags($post['location'])),
            );
        } else {
            $address_id = trim(strip_tags($post['id']));
            foreach ($order['address'] as $key => $addrr) {
                if ($addrr['id'] == $address_id) {
                    $order['address'][$key] = array(
                        'id' => $address_id,
                        'city' => trim(strip_tags($post['city'])),
                        'state' => trim(strip_tags($post['state'])),
                        'address' => trim(strip_tags($post['address'])),
                        'location' => trim(strip_tags($post['location'])),
                    );
                    break;
                }
            }
        }
        $order['cart_form']['address'] = 'wppp' . $address_id;
        return $order;
    }

    public static function itemCountTotal($key, $float = false) {
        $order = Helpers::getSessionOrder();
        $id = $order['items'][$key]['id'];
        $item = MMItem::model()->with(array(
                    'params' => array(
                        'together' => true,
                        'with' => array(
                            'attribs' => array(
                                'together' => true
                            )
                        )
                    )
                ))->findByPk($id);
        $price = (float) $item->price;
        if (is_array($order['items'][$key]['attributes'])) {
            foreach ($item->params as $param) {
                foreach ($param->attribs as $attribute) {
                    if (array_key_exists((int) $attribute->id, $order['items'][$key]['attributes']))
                        $price += (float) $attribute->price;
                }
            }
        }
        return $float ? $price : number_format($price, 2);
    }

    public static function deleteSessionItem($id) {
        $order = Yii::app()->session['wpmm_order'];
        unset($order['items'][$id]);
        Yii::app()->session['wpmm_order'] = $order;
        return !isset($order['items'][$id]);
    }

    public static function getDiscountInfo($calculate = false, $number = false) {
        $discount = (float) MMSettingsForm::getParam('discount');
        if ($calculate) {
            $value = $discount / 100 * Helpers::getOrderSubtotal();
            if ($number)
                return $value;
            $info = 'Discount (' . number_format($discount, 2) . '%): <strong>-$' . number_format($value, 2);
        } else {
            $info = 'Discount: <strong>-' . number_format($discount, 2) . '%';
        }
        $info .= '</strong>';
        return $info;
    }

    public static function getTaxInfo($calculate = false, $number = false) {
        $taxrate = (float) MMSettingsForm::getParam('tax_rate');
        if ($calculate) {
            $value = $taxrate / 100 * (Helpers::getOrderSubtotal() - Helpers::getDiscountInfo(true, true));
            if ($number)
                return $value;
            $info = 'Tax (' . number_format($taxrate, 2) . '%): <strong>$' . number_format($value, 2);
        } else {
            $info = 'Tax: <strong>' . number_format($taxrate, 2) . '%';
        }
        $info .= '</strong>';
        return $info;
    }

    public static function getDeliveryInfo($number = false) {
        $deliverycharge = (float) MMSettingsForm::getParam('delivery_charge');
        if ($number)
            return $deliverycharge;
        else {
            $info = 'Delivery charge: <strong>$' . number_format($deliverycharge, 2);
        }
        $info .= '</strong>';
        return $info;
    }

    public static function getTipInfo($calculate = false, $number = false) {
        $order = Helpers::getSessionOrder();
        $info = 'Tip: <strong>';
        if ($calculate) {
            switch ($order['cart_form']['payment-tip-type']) {
                case 'percent':
                    $info = 'Tip (' . number_format((float) $order['cart_form']['payment-tip-value'], 2) . '%): <strong>';
                    $value = (float) $order['cart_form']['payment-tip-value'] / 100 * Helpers::getOrderSubtotal();
                    $info .= '$' . number_format($value, 2);
                    break;
                case 'amount':
                    $value = (float) $order['cart_form']['payment-tip-value'];
                    $info .= '$' . number_format($value, 2);
                    break;
            }
            if ($number)
                return $value;
        } else {
            switch ($order['cart_form']['payment-tip-type']) {
                case 'percent':
                    $info .= number_format((float) $order['cart_form']['payment-tip-value'], 2) . '%';
                    break;
                case 'amount':
                    $info .= '$' . number_format((float) $order['cart_form']['payment-tip-value'], 2);
                    break;
            }
        }
        $info .= '</strong>';
        return $info;
    }

    public static function getOrderSubtotal() {
        $order = Helpers::getSessionOrder();
        foreach ($order['items'] as $key => $item) {
            $subtotal += Helpers::itemCountTotal($key, true) * (int) $item['quantity'];
        }
        return $subtotal;
    }

    public static function getOrderTotal($number = false) {
        $order = Helpers::getSessionOrder();
        $total = Helpers::getOrderSubtotal();
        $params = MMSettingsForm::getParams();
        if ($params['discount'] > 0) {
            $total -= Helpers::getDiscountInfo(true, true);
        }
        if ($params['tax_rate'] > 0) {
            $total += Helpers::getTaxInfo(true, true);
        }
        if ($order['cart_form']['payment-tip-value'] > 0) {
            $total += Helpers::getTipInfo(true, true);
        }
        if ($order['cart_form']['delivery-type'] == 'Delivery') {
            $total += Helpers::getDeliveryInfo(true);
        }
        return $number ? (float) $total : number_format((float) $total, 2);
    }

    public static function getWorkingHours($time_string) {
        $timestamp = strtotime($time_string);
        if (!$timestamp)
            return 'Incorrect delivery time.';
        $dayofweek = (int) date('w', $timestamp);
        $worktime = unserialize(MMSettingsForm::getParam('work_time'));
        $hours_array = Helpers::GetHours();
        return '<div style="text-align: center; margin-left: -10px">
                Selected date working hours:<br>' . $hours_array[(int) $worktime[$dayofweek]['from']] . ' - ' . $hours_array[(int) $worktime[$dayofweek]['to']] .
            '</div>';
        ;
    }

    public static function validateWorkingHours($time_string) {
        $timestamp = strtotime($time_string);
        if (!$timestamp)
            return false;
        if ($timestamp < time())
            return false;
        $hour = (int) date('G', $timestamp);
        $dayofweek = (int) date('w', $timestamp);
        $worktime = unserialize(MMSettingsForm::getParam('work_time'));
        if ($worktime[$dayofweek]['from'] > $worktime[$dayofweek]['to'])
            $overnight = true;
        elseif ($worktime[$dayofweek]['from'] == $worktime[$dayofweek]['to'])
            return true;
        if ($overnight) {
            if ($worktime[$dayofweek]['active'] && ($worktime[$dayofweek]['from'] <= $hour || $worktime[$dayofweek]['to'] > $hour))
                return true;
        } else {
            if ($worktime[$dayofweek]['active'] && $worktime[$dayofweek]['from'] <= $hour && $worktime[$dayofweek]['to'] > $hour)
                return true;
        }
        return false;
    }

    public static function validateItemTime($id) {
        $valid = false;
        $item = MMItem::model()->with(array(
                    'categories' => array(
                        'together' => true,
                        'with' => array(
                            'menus' => array(
                                'together' => true
                            )
                        )
                    )
                ))->findByPk($id);
        foreach ($item->categories as $category) {
            foreach ($category->menus as $menu) {
                $menu_ids[] = $menu->id;
            }
        }
        $hour_now = (int) date('G', time());
        $menus = MMMenu::model()->findAllByPk(array_unique($menu_ids));
        foreach ($menus as $menu) {
            if ($menu->time_from == $menu->time_to) {
                $valid = true;
            } elseif ($menu->published && $menu->time_from <= $hour_now && $menu->time_to > $hour_now) {
                $valid = true;
            }
        }
        return $valid;
    }

    public static function sendOrderToEmail($order,$email,$full=false){
       YiiBase::import('ext.YiiMail.YiiMailMessage');
       $shopemail = MMSettingsForm::getParam('vendor_email');
       $shopname = MMSettingsForm::getParam('vendor_name');
       $message = new YiiMailMessage;
       $message->setBody(Yii::app()->controller->renderPartial('//admin/_orderblank', array('model' => $order, 'full' => $full), true).self::shopDetails(), 'text/html', 'utf-8');
       $message->addTo($email);
       $message->setFrom(array($shopemail => $shopname));
       $message->setReplyTo(array($shopemail => $shopname));
       $message->setSubject("Order N-" . $order->id . " information");
       Yii::app()->mail->send($message);
    }

    public static function sendRegisterMessage($user, $pass) {
        YiiBase::import('ext.YiiMail.YiiMailMessage');
        $shopemail = MMSettingsForm::getParam('vendor_email');
        $shopname = MMSettingsForm::getParam('vendor_name');
        $message = new YiiMailMessage;
        $message->setBody('<b>Dear Customer</b><br>You have registered on to :<b>' . $shopname . '</b> by submiting order from us. Your account is<br>Username: ' . $user->c_mail . '<br>Password: ' . $pass . '<br><b>Thank you for using our service!</b> ' . self::shopDetails(), 'text/html', 'utf-8');
        $message->addTo($user->c_mail);
        $message->setFrom(array($shopemail => $shopname));
        $message->setReplyTo(array($shopemail => $shopname));
        $message->setSubject("Registration to: " . $shopname);
        Yii::app()->mail->send($message);
    }

    public static function shopDetails(){
        $message='<br><hr><br>If you have questions, ask us by any of this contacts:';
        $email=MMSettingsForm::getParam('vendor_email');
        $phone=MMSettingsForm::getParam('vendor_phone');
        $fax=MMSettingsForm::getParam('vendor_fax');
        if(!empty($email))
            $message.='<br><b>Email: </b>'.$email;
        if(!empty($phone))
            $message.='<br><b>Phone: </b>'.$phone;
        if(!empty($fax))
            $message.='<br><b>Fax: </b>'.$fax;
        return $message;
    }

    public static function renderSelectedAttribute($attribute) {
        global $selected_attrs;
        global $first;
        if ($first) {
            $selected_attrs = '<div id="selected-attributes">
                    <div class="wpmm-form-info">
                    <p>Selected options:</p>
                    <table>';
            $first = false;
        }
        $selected_attrs .=
            '<tr>
                <td>' . $attribute->name . '</td>' .'
                <td width="65" class="selected-attr-price">' . ((substr($attribute->price, 0, 1) === '-') ? '- $' . substr($attribute->price, 1) : '+ $' . $attribute->price) . '</td>
            </tr>';
    }

}
